#
# KXmms gdesklets Control
# Copyright 2005 - Andrea Briganti <kbytesys@tin.it>
# Version 0.1
#
# This Control was inspired by the Stefano Mozzi's CornerXMMS Sensor
#
# This Control is released under GPL 2.0 Licence.

from libdesklets.controls import Control

import time

from IKIconAnim import IKIconAnim

class KIconAnim(Control, IKIconAnim):
	def __init__(self):
		Control.__init__(self)
		self.__zoom = 1.0
		self.__factor = 0.1
		self.__icon = 0
		self._add_timer( 30, self.__timer )

	def __timer(self):
		if(self.__icon == 0):
			return True
		
		if self.__icon.scale == self.__zoom:
			return True
		
		if self.__icon.scale < self.__zoom:
			sign = 1
		else:
			sign = -1

		tmpZoom = self.__icon.scale + (self.__factor * sign)
		if(sign > 0):
			if tmpZoom > self.__zoom:
				tmpZoom = self.__zoom
		else:
			if tmpZoom < self.__zoom:
				tmpZoom = self.__zoom

		self.__icon.scale = tmpZoom

		return True

	def __seticon(self, obj):
		self.__icon = obj

	def __setscale(self, value):
		zoom, factor = value
		self.__zoom = zoom
		self.__factor = factor

	setscale = property(fset = __setscale)
	seticon = property(fset = __seticon)

def get_class(): return KIconAnim
